#include "mainwindowimpl.h"
//
MainWindowImpl::MainWindowImpl( QWidget * parent, Qt::WFlags f) 
	: QMainWindow(parent, f)
{
	setupUi(this);
}

void MainWindowImpl::test( )
{
    HMODULE h = LoadLibrary ( QString( "wtclient.dll" ).toStdWString().c_str() );
    typedef int (*FNumServ) ( bool, LPCSTR ) ;
	typedef void (*FDisconnect) (HANDLE);
    if (h==NULL)
    {
        QMessageBox::warning( 0, "Loading DLL", "Error loading DLL through API");
    }
    else
    {
        FNumServ NumberOfServers = (FNumServ)( GetProcAddress ( h, QString( "NumberOfOPCServers" ).toStdString().c_str() ));
        FDisconnect DisconnectOPC = (FDisconnect) GetProcAddress ( h, QString( "DisconnectOPC" ).toStdString().c_str() );
        if (NumberOfServers==NULL)
        {
            QMessageBox::warning( 0, "Getting function", "Error getting NumberOfOPCServers through API");
        }
        if (DisconnectOPC==NULL)
        {
            QMessageBox::warning( 0, "Getting function", "Error getting DisconnectOPC through API");
        }
        FreeLibrary(h);
    }
	QLibrary lib( "wtclient" );
	lib.load();
	if (!lib.isLoaded())
	{
        QMessageBox::warning( 0, "Loading DLL", "Error loading DLL");
	}
	else
	{
		FNumServ NumberOfOPCServers = (FNumServ) lib.resolve( "NumberOfOPCServers" );
		FDisconnect DisconnectOPC = (FDisconnect) lib.resolve ( "DisconnectOPC" );
		if (NumberOfOPCServers==NULL)
		{
			QMessageBox::warning( 0, "Getting function", "Error getting NumberOfOPCServers");
		}
		else
		{
		    int num = NumberOfOPCServers( false, QString( "" ).toStdString().c_str() );
		    QMessageBox::information( 0, "NumOfServers", QString( "" ).setNum( num ) );	
		}
		if (DisconnectOPC==NULL)
		{
			QMessageBox::warning( 0, "Getting function", "Error getting DisconnectOPC" );
		}
		else
		{
		    QMessageBox::information( 0, "Getting function", "Got DisconnectOPC" );	
		}
		lib.unload();
	}
}
//
